using System;
using System.Collections;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public class WebForm6 : System.Web.UI.Page
{
	protected System.Web.UI.WebControls.DataList DataList;

	//	}`EC̃f[^AŎgp邽߂̌^B
	[Serializable]
		public class MyData
	{
		public string f1;
		public string f2;

		public string F1
		{
			get { return this.f1; }
		}

		public string F2
		{
			get { return this.f2; }
		}

		public MyData(string f1, string f2)
		{
			this.f1 = f1;
			this.f2 = f2;
		}
	}

	private void Page_Load(object sender, EventArgs e)
	{
		if (!IsPostBack)
		{
			ViewState["MyDataList"] = new ArrayList(new MyData[] 
				{ new MyData("a", "b"), new MyData("c", "d") });

			//	f[^AwB
			this.DataList.DataSource = ViewState["MyDataList"];
			this.DataBind();
		}
	}

	private void DataList_EditCommand(
		object source, DataListCommandEventArgs e)
	{
		//	ҏWΏۍsݒB
		this.DataList.EditItemIndex = e.Item.ItemIndex;	

		//	f[^AB
		this.DataList.DataSource = ViewState["MyDataList"];
		this.DataBind();
	}

	private void DataList_UpdateCommand(
		object source, DataListCommandEventArgs e)
	{
		//	f[^XVB
		//	͂ꂽĺAZ̒ɂRg[
		//	擾܂B
		IList myDataList = (IList)ViewState["MyDataList"];
		myDataList[e.Item.ItemIndex] = new MyData(
			((TextBox)e.Item.Controls[1]).Text,
			((TextBox)e.Item.Controls[3]).Text);
		ViewState["MyDataList"] = myDataList;

		//	ҏW[hB
		this.DataList.EditItemIndex = -1;

		//	f[^AB
		this.DataList.DataSource = ViewState["MyDataList"];
		this.DataBind();
	}

	private void DataList_CancelCommand(
		object source, DataListCommandEventArgs e)
	{
		//	ҏW[hB
		this.DataList.EditItemIndex = -1;

		//	f[^AB
		this.DataList.DataSource = ViewState["MyDataList"];
		this.DataBind();
	}

	private void DataList_DeleteCommand(
		object source, DataListCommandEventArgs e)
	{
		//	ΏۃR[h폜B
		IList myDataList = (IList)ViewState["MyDataList"];
		myDataList.RemoveAt(e.Item.ItemIndex);
		ViewState["MyDataList"] = myDataList;

		//	ҏW[hB
		this.DataList.EditItemIndex = -1;

		//	f[^AB
		this.DataList.DataSource = ViewState["MyDataList"];
		this.DataBind();
	}

	override protected void OnInit(EventArgs e)
	{
		InitializeComponent();
		base.OnInit(e);
	}
	
	private void InitializeComponent()
	{    
		this.Load += 
			new EventHandler(this.Page_Load);
		this.DataList.EditCommand += 
			new DataListCommandEventHandler(this.DataList_EditCommand);
		this.DataList.UpdateCommand += 
			new DataListCommandEventHandler(this.DataList_UpdateCommand);
		this.DataList.CancelCommand += 
			new DataListCommandEventHandler(this.DataList_CancelCommand);
		this.DataList.DeleteCommand += 
			new DataListCommandEventHandler(this.DataList_DeleteCommand);
	}
}